require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&__LINUX_FILTER_H__)) {
    eval 'sub __LINUX_FILTER_H__ () {1;}' unless defined(&__LINUX_FILTER_H__);
    require 'linux/types.ph';
    eval 'sub BPF_MAJOR_VERSION () {1;}' unless defined(&BPF_MAJOR_VERSION);
    eval 'sub BPF_MINOR_VERSION () {1;}' unless defined(&BPF_MINOR_VERSION);
    eval 'sub BPF_CLASS {
        my($code) = @_;
	    eval q((($code) & 0x7));
    }' unless defined(&BPF_CLASS);
    eval 'sub BPF_LD () {0x;}' unless defined(&BPF_LD);
    eval 'sub BPF_LDX () {0x1;}' unless defined(&BPF_LDX);
    eval 'sub BPF_ST () {0x2;}' unless defined(&BPF_ST);
    eval 'sub BPF_STX () {0x3;}' unless defined(&BPF_STX);
    eval 'sub BPF_ALU () {0x4;}' unless defined(&BPF_ALU);
    eval 'sub BPF_JMP () {0x5;}' unless defined(&BPF_JMP);
    eval 'sub BPF_RET () {0x6;}' unless defined(&BPF_RET);
    eval 'sub BPF_MISC () {0x7;}' unless defined(&BPF_MISC);
    eval 'sub BPF_SIZE {
        my($code) = @_;
	    eval q((($code) & 0x18));
    }' unless defined(&BPF_SIZE);
    eval 'sub BPF_W () {0x;}' unless defined(&BPF_W);
    eval 'sub BPF_H () {0x8;}' unless defined(&BPF_H);
    eval 'sub BPF_B () {0x10;}' unless defined(&BPF_B);
    eval 'sub BPF_MODE {
        my($code) = @_;
	    eval q((($code) & 0xe0));
    }' unless defined(&BPF_MODE);
    eval 'sub BPF_IMM () {0x;}' unless defined(&BPF_IMM);
    eval 'sub BPF_ABS () {0x20;}' unless defined(&BPF_ABS);
    eval 'sub BPF_IND () {0x40;}' unless defined(&BPF_IND);
    eval 'sub BPF_MEM () {0x60;}' unless defined(&BPF_MEM);
    eval 'sub BPF_LEN () {0x80;}' unless defined(&BPF_LEN);
    eval 'sub BPF_MSH () {0xa0;}' unless defined(&BPF_MSH);
    eval 'sub BPF_OP {
        my($code) = @_;
	    eval q((($code) & 0xf0));
    }' unless defined(&BPF_OP);
    eval 'sub BPF_ADD () {0x;}' unless defined(&BPF_ADD);
    eval 'sub BPF_SUB () {0x10;}' unless defined(&BPF_SUB);
    eval 'sub BPF_MUL () {0x20;}' unless defined(&BPF_MUL);
    eval 'sub BPF_DIV () {0x30;}' unless defined(&BPF_DIV);
    eval 'sub BPF_OR () {0x40;}' unless defined(&BPF_OR);
    eval 'sub BPF_AND () {0x50;}' unless defined(&BPF_AND);
    eval 'sub BPF_LSH () {0x60;}' unless defined(&BPF_LSH);
    eval 'sub BPF_RSH () {0x70;}' unless defined(&BPF_RSH);
    eval 'sub BPF_NEG () {0x80;}' unless defined(&BPF_NEG);
    eval 'sub BPF_JA () {0x;}' unless defined(&BPF_JA);
    eval 'sub BPF_JEQ () {0x10;}' unless defined(&BPF_JEQ);
    eval 'sub BPF_JGT () {0x20;}' unless defined(&BPF_JGT);
    eval 'sub BPF_JGE () {0x30;}' unless defined(&BPF_JGE);
    eval 'sub BPF_JSET () {0x40;}' unless defined(&BPF_JSET);
    eval 'sub BPF_SRC {
        my($code) = @_;
	    eval q((($code) & 0x8));
    }' unless defined(&BPF_SRC);
    eval 'sub BPF_K () {0x;}' unless defined(&BPF_K);
    eval 'sub BPF_X () {0x8;}' unless defined(&BPF_X);
    eval 'sub BPF_RVAL {
        my($code) = @_;
	    eval q((($code) & 0x18));
    }' unless defined(&BPF_RVAL);
    eval 'sub BPF_A () {0x10;}' unless defined(&BPF_A);
    eval 'sub BPF_MISCOP {
        my($code) = @_;
	    eval q((($code) & 0xf8));
    }' unless defined(&BPF_MISCOP);
    eval 'sub BPF_TAX () {0x;}' unless defined(&BPF_TAX);
    eval 'sub BPF_TXA () {0x80;}' unless defined(&BPF_TXA);
    eval("sub BPF_S_RET_K () { 0; }") unless defined(&BPF_S_RET_K);
    eval("sub BPF_S_RET_A () { 1; }") unless defined(&BPF_S_RET_A);
    eval("sub BPF_S_ALU_ADD_K () { 2; }") unless defined(&BPF_S_ALU_ADD_K);
    eval("sub BPF_S_ALU_ADD_X () { 3; }") unless defined(&BPF_S_ALU_ADD_X);
    eval("sub BPF_S_ALU_SUB_K () { 4; }") unless defined(&BPF_S_ALU_SUB_K);
    eval("sub BPF_S_ALU_SUB_X () { 5; }") unless defined(&BPF_S_ALU_SUB_X);
    eval("sub BPF_S_ALU_MUL_K () { 6; }") unless defined(&BPF_S_ALU_MUL_K);
    eval("sub BPF_S_ALU_MUL_X () { 7; }") unless defined(&BPF_S_ALU_MUL_X);
    eval("sub BPF_S_ALU_DIV_X () { 8; }") unless defined(&BPF_S_ALU_DIV_X);
    eval("sub BPF_S_ALU_AND_K () { 9; }") unless defined(&BPF_S_ALU_AND_K);
    eval("sub BPF_S_ALU_AND_X () { 10; }") unless defined(&BPF_S_ALU_AND_X);
    eval("sub BPF_S_ALU_OR_K () { 11; }") unless defined(&BPF_S_ALU_OR_K);
    eval("sub BPF_S_ALU_OR_X () { 12; }") unless defined(&BPF_S_ALU_OR_X);
    eval("sub BPF_S_ALU_LSH_K () { 13; }") unless defined(&BPF_S_ALU_LSH_K);
    eval("sub BPF_S_ALU_LSH_X () { 14; }") unless defined(&BPF_S_ALU_LSH_X);
    eval("sub BPF_S_ALU_RSH_K () { 15; }") unless defined(&BPF_S_ALU_RSH_K);
    eval("sub BPF_S_ALU_RSH_X () { 16; }") unless defined(&BPF_S_ALU_RSH_X);
    eval("sub BPF_S_ALU_NEG () { 17; }") unless defined(&BPF_S_ALU_NEG);
    eval("sub BPF_S_LD_W_ABS () { 18; }") unless defined(&BPF_S_LD_W_ABS);
    eval("sub BPF_S_LD_H_ABS () { 19; }") unless defined(&BPF_S_LD_H_ABS);
    eval("sub BPF_S_LD_B_ABS () { 20; }") unless defined(&BPF_S_LD_B_ABS);
    eval("sub BPF_S_LD_W_LEN () { 21; }") unless defined(&BPF_S_LD_W_LEN);
    eval("sub BPF_S_LD_W_IND () { 22; }") unless defined(&BPF_S_LD_W_IND);
    eval("sub BPF_S_LD_H_IND () { 23; }") unless defined(&BPF_S_LD_H_IND);
    eval("sub BPF_S_LD_B_IND () { 24; }") unless defined(&BPF_S_LD_B_IND);
    eval("sub BPF_S_LD_IMM () { 25; }") unless defined(&BPF_S_LD_IMM);
    eval("sub BPF_S_LDX_W_LEN () { 26; }") unless defined(&BPF_S_LDX_W_LEN);
    eval("sub BPF_S_LDX_B_MSH () { 27; }") unless defined(&BPF_S_LDX_B_MSH);
    eval("sub BPF_S_LDX_IMM () { 28; }") unless defined(&BPF_S_LDX_IMM);
    eval("sub BPF_S_MISC_TAX () { 29; }") unless defined(&BPF_S_MISC_TAX);
    eval("sub BPF_S_MISC_TXA () { 30; }") unless defined(&BPF_S_MISC_TXA);
    eval("sub BPF_S_ALU_DIV_K () { 31; }") unless defined(&BPF_S_ALU_DIV_K);
    eval("sub BPF_S_LD_MEM () { 32; }") unless defined(&BPF_S_LD_MEM);
    eval("sub BPF_S_LDX_MEM () { 33; }") unless defined(&BPF_S_LDX_MEM);
    eval("sub BPF_S_ST () { 34; }") unless defined(&BPF_S_ST);
    eval("sub BPF_S_STX () { 35; }") unless defined(&BPF_S_STX);
    eval("sub BPF_S_JMP_JA () { 36; }") unless defined(&BPF_S_JMP_JA);
    eval("sub BPF_S_JMP_JEQ_K () { 37; }") unless defined(&BPF_S_JMP_JEQ_K);
    eval("sub BPF_S_JMP_JEQ_X () { 38; }") unless defined(&BPF_S_JMP_JEQ_X);
    eval("sub BPF_S_JMP_JGE_K () { 39; }") unless defined(&BPF_S_JMP_JGE_K);
    eval("sub BPF_S_JMP_JGE_X () { 40; }") unless defined(&BPF_S_JMP_JGE_X);
    eval("sub BPF_S_JMP_JGT_K () { 41; }") unless defined(&BPF_S_JMP_JGT_K);
    eval("sub BPF_S_JMP_JGT_X () { 42; }") unless defined(&BPF_S_JMP_JGT_X);
    eval("sub BPF_S_JMP_JSET_K () { 43; }") unless defined(&BPF_S_JMP_JSET_K);
    eval("sub BPF_S_JMP_JSET_X () { 44; }") unless defined(&BPF_S_JMP_JSET_X);
    unless(defined(&BPF_MAXINSNS)) {
	eval 'sub BPF_MAXINSNS () {4096;}' unless defined(&BPF_MAXINSNS);
    }
    unless(defined(&BPF_STMT)) {
	eval 'sub BPF_STMT {
	    my($code, $k) = @_;
    	    eval q({ ($code), 0, 0, $k });
	}' unless defined(&BPF_STMT);
    }
    unless(defined(&BPF_JUMP)) {
	eval 'sub BPF_JUMP {
	    my($code, $k, $jt, $jf) = @_;
    	    eval q({ ($code), $jt, $jf, $k });
	}' unless defined(&BPF_JUMP);
    }
    eval 'sub BPF_MEMWORDS () {16;}' unless defined(&BPF_MEMWORDS);
    eval 'sub SKF_AD_OFF () {(-0x1000);}' unless defined(&SKF_AD_OFF);
    eval 'sub SKF_AD_PROTOCOL () {0;}' unless defined(&SKF_AD_PROTOCOL);
    eval 'sub SKF_AD_PKTTYPE () {4;}' unless defined(&SKF_AD_PKTTYPE);
    eval 'sub SKF_AD_IFINDEX () {8;}' unless defined(&SKF_AD_IFINDEX);
    eval 'sub SKF_AD_NLATTR () {12;}' unless defined(&SKF_AD_NLATTR);
    eval 'sub SKF_AD_NLATTR_NEST () {16;}' unless defined(&SKF_AD_NLATTR_NEST);
    eval 'sub SKF_AD_MARK () {20;}' unless defined(&SKF_AD_MARK);
    eval 'sub SKF_AD_QUEUE () {24;}' unless defined(&SKF_AD_QUEUE);
    eval 'sub SKF_AD_HATYPE () {28;}' unless defined(&SKF_AD_HATYPE);
    eval 'sub SKF_AD_MAX () {32;}' unless defined(&SKF_AD_MAX);
    eval 'sub SKF_NET_OFF () {(-0x100000);}' unless defined(&SKF_NET_OFF);
    eval 'sub SKF_LL_OFF () {(-0x200000);}' unless defined(&SKF_LL_OFF);
}
1;
